package ActivatePackage
{
  function Player::activateStuff(%this)
  {
    %client = %this.client;
    %item = %this.tool[%this.currTool];

    if (!isObject(%client) || %client.miniGame != $DefaultMiniGame)
      return Parent::activateStuff(%this);

    if (isObject(%item) && !isObject(%item.image))
      return Parent::activateStuff(%this);

    if (%this.getDamagePercent() >= 1)
      return 0;

    if (getSimTime() - %this.lastActivateTime <= 320)
      %this.activateLevel++;
    else
      %this.activateLevel = 0;

    %this.lastActivateTime = getSimTime();

    if (%this.activateLevel >= 5)
      %this.playThread(3, "activate2");
    else
      %this.playThread(3, "activate");

    %start = %this.getEyePoint();
    %path = vectorScale(%this.getEyeVector(), 6);
    %end = vectorAdd(%start, %path);

    %mask = (
      $TypeMasks::ItemObjectType |
      $TypeMasks::PlayerObjectType |
      $TypeMasks::VehicleObjectType |
      $TypeMasks::FxBrickObjectType
    );

    %exempt = %this;

    if (%this.isMounted())
      %exempt = %this.getObjectMount();

    %ray = containerRayCast(%start, %end, %mask, %exempt);

    if (!%ray)
      return 0;

    %ray.onActivate(%this, %client, getWords(%ray, 1, 3), %path);
    return getWord(%ray, 0);
  }

  function Item::onActivate(%this, %obj, %client, %pos, %vec)
  {
    %obj.pickup(%this);
  }

  function Player::onActivate(%this, %obj, %client, %pos, %vec)
  {
    if (%this == %obj || !%this.getDataBlock().rideAble || %obj.isMounted())
      return;

    %pos = %obj.getTransform();

    %obj.setTransform(vectorAdd(%pos, "0 0 100"));
    %this.getDatablock().onCollision(%this, %obj, 0, 0, 1);

    if (!%obj.isMounted())
      %obj.setTransform(%pos);
  }

  function Vehicle::onActivate(%this, %obj, %client, %pos, %vec)
  {
    if (%obj.isMounted())
    {
      Parent::onActivate(%this, %obj, %client, %pos, %vec);
      return;
    }

    %pos = %obj.getTransform();

    %obj.setTransform(vectorAdd(%pos, "0 0 100"));
    //%this.getDatablock().onCollision(%this, %obj, 0, 0, 1);
    WheeledVehicleData::onCollision(%this.getDataBlock(), %this, %obj, 0, 0, 1);

    if (!%obj.isMounted())
    {
      //talk("couldn't mount for some reason");
      %obj.setTransform(%pos);
    }
  }

  function Armor::onCollision(%this, %obj, %col, %vec, %vel, %parent)
  {
    if (%parent || !(%col.getType() & $TypeMasks::ItemObjectType) && !(%col.getType() & $TypeMasks::PlayerObjectType))
      Parent::onCollision(%this, %obj, %col, %vec, %vel);
  }

  function WheeledVehicleData::onCollision(%this, %obj, %col, %vec, %vel, %parent)
  {
    if (%parent)
      Parent::onCollision(%this, %obj, %col, %vec, %vel);
  }
};

activatePackage("ActivatePackage");
