datablock itemData( lootMetalPanelItem : lootPebblesItem )
{
	shapeFile = "Add-Ons/GameMode_Survival/shapes/bar.dts";
	uiName = "Metal Panel";
	doColorShift = true;
	colorShiftColor = "0.8 0.8 0.9 1";
	itemDesc = "A useful material. Can be used to repair vehicles.";
	invMass = 10;

	image = lootMetalPanelImage;
};

datablock ShapeBaseImageData(lootMetalPanelImage)
{
	shapeFile = "Add-Ons/GameMode_Survival/shapes/bar.dts";
	item = LootMetalPanelItem;

	doColorShift = LootMetalPanelItem.doColorShift;
	colorShiftColor = LootMetalPanelItem.colorShiftColor;

	stateName[0] = "Ready";
	stateTransitionOnTriggerDown[0] = "Use";

	stateName[1] = "Use";
	stateScript[1] = "onUse";
	stateTransitionOnTriggerUp[0] = "Ready";
};

function lootMetalPanelImage::onUse(%this, %obj, %slot)
{
	%start = %obj.getEyePoint();
	%end = vectorAdd(%start, vectorScale(%obj.getEyeVector(), 6));
	%ray = containerRayCast(%start, %end,
		$TypeMasks::VehicleObjectType |
		$TypeMasks::FxBrickObjectType
	);

	%col = getWord(%ray, 0);
	if(isObject(%col) && %col.getType() & $TypeMasks::VehicleObjectType)
	{
		%heal = %col.getDatablock().maxDamage / getRandom(3, 4);
		%col.setDamageLevel(%col.getDamageLevel() - %heal);
		%obj.tool[%obj.currTool] = 0;
		messageClient(%obj.client, 'MsgItemPickup', '', %obj.currTool, 0);
		%obj.unMountImage(0);
	}
}

datablock itemData( lootCanOpenerItem : lootPebblesItem )
{
	shapeFile = "Add-Ons/GameMode_Survival/shapes/canOpener.dts";
	uiName = "Can Opener";
	doColorShift = true;
	colorShiftColor = "0.8 0.2 0.2 1";
	itemDesc = "With this, you can finally open canned foods.";
	invMass = 5;

	image = lootCanOpenerImage;
};

datablock ShapeBaseImageData(lootCanOpenerImage)
{
	shapeFile = "Add-Ons/GameMode_Survival/shapes/canOpener.dts";
	item = LootCanOpenerItem;

	doColorShift = LootCanOpenerItem.doColorShift;
	colorShiftColor = LootCanOpenerItem.colorShiftColor;

	stateName[0] = "Ready";
	stateTransitionOnTriggerDown[0] = "Use";

	stateName[1] = "Use";
	stateScript[1] = "onUse";
	stateTransitionOnTriggerUp[0] = "Ready";
};

function lootCanOpenerImage::onUse(%this, %obj, %slot)
{
	%slots = %obj.getDataBlock().maxTools;
	for(%i = 0; %i < %slots; %i++)
	{
		if(%obj.tool[%i] == nameToID(lootCannedFoodItem))
		{
			%obj.tool[%i] = nameToID(lootCannedFoodOpenedItem);
			messageClient(%obj.client, 'MsgItemPickup', '', %i, %obj.tool[%i]);
		}
		else if (%obj.tool[%i] == nameToID(lootCannedFoodSmallItem))
		{
			%obj.tool[%i] = nameToID(lootCannedFoodSmallOpenedItem);
			messageClient(%obj.client, 'MsgItemPickup', '', %i, %obj.tool[%i]);
		}
	}
	messageClient(%obj.client, '', '\c3All your locked cans have been unlocked!');
}