function serverCmdClearItems(%client)
{
	if (!%client.isAdmin)
		return;

	%count = 0;

	for (%i = 0; %i < MainBrickGroup.getCount(); %i++)
	{
		%group = MainBrickGroup.getObject(%i);

		for (%j = 0; %j < %group.getCount(); %j++)
		{
			%brick = %group.getObject(%i);

			if (isObject(%brick.item))
				%count++;

			%brick.setItem(0);
		}
	}

	for (%i = MissionCleanup.getCount() - 1; %i >= 0; %i--)
	{
		%object = MissionCleanup.getObject(%i);

		if (%object.getClassName() $= "Item")
		{
			%object.delete();
			%count++;
		}
	}

	if (%count)
		messageAll('MsgClearBricks', '\c3%1 \c0cleared all items. (%2)', %client.name, %count);
}

function spawnLoot()
{
	cancel($spawnLoot);

	// Trash
	%items0 = "lootPebblesItem lootTrashCartonItem lootTrashCanItem lootStoneItem lootBranchItem";
	// Common food
	%items1 = "lootBerriesItem lootCannedFoodItem lootCannedFoodSmallItem lootCannedFoodKeyItem lootCannedFoodKeySmallItem";
	// Drinkable
	%items2 = "lootBeerItem lootSodaItem lootWaterItem lootMetalPanelItem lootJuiceCartonItem lootMilkCartonItem";
	// Useful
	%items3 = "lootRagItem lootBandageItem lootGasCanItem cleanSprayItem";
	// Weak melee
	%items4 = "lootCanOpenerItem meleeUmbrellaItem meleePanItem meleeKnifeItem meleeCaneItem servicePistolItem";
	// Sidearms
	%items5 = "machinePistolItem automaticPistolItem revolverItem";
	// Misc weapons
	%items6 = "combatRifleItem fieldRifleItem gamePistolItem huntingMagnumItem huntingRifleItem";
	// High-power weapons
	%items7 = "sniperRifleItem singleShotgunItem huntingShotgunItem doubleShotgunItem leverRifleItem leverShotgunItem";
	// Light auto weapons
	%items8 = "submachineGunItem carbineSMGItem automaticRifleItem assaultRifleItem";
	// Top tier weapons
	%items9 = "riotShotgunItem pairedShotgunItem";

	%quantity = getRandom(7, 30);

	for (%i = 0; %i < %quantity; %i++)
	{
		%quality = getRandom(9);

		%name = "_lootspawn_" @ %quality;
		%count = BrickGroup_888888.NTObjectCount[%name];

		if (!%count)
			continue;

		%index = getRandom(%count - 1);
		%spawn = BrickGroup_888888.NTObject[%name, %index];

		if (isObject(%spawn.item))
			continue;

		%items = %items[%quality];

		for (%j = 1; %j <= 3; %j++)
			%items = %items SPC %items[%quality - %j];

		%item = getWord(%items, getRandom(getWordCount(%items) - 1));

		if (isObject(%item))
		{
			%spawn.item = new Item()
			{
				datablock = %item;
				isLoot = 1;
				static = 1;
				// rotate = 1;
			};

			MissionCleanup.add(%spawn.item);
			%spawn.setItemDirection(getRandom(3)); //mFloor(%spawn.itemDirection)
		}
		else
		{
			// talk("ERROR: Loot" SPC %item SPC "does not exist!");
		}
	}

	if (getRandom() < 0.15)
	{
		%className = FlyingVehicle;
		%vehicleMax = 2;

		%vehicle0 = CityHeliMedVehicle;
		%vehicle1 = CityHeliSmlVehicle;
		%vehicle2 = BiplaneVehicle;
	}
	else
	{
		%className = WheeledVehicle;
		%vehicleMax = 9;

		%vehicle0 = TMDesertVehicle;
		%vehicle1 = TMIslandVehicle;
		%vehicle2 = TMRallyVehicle;
		%vehicle3 = TMSnowVehicle;
		%vehicle4 = TMValleyVehicle;
		%vehicle5 = TMValley2Vehicle;
		%vehicle6 = ATVVehicle;
		%vehicle7 = gc_ExplorerVehicle;
		%vehicle8 = gc_ExplorerOffroadVehicle;
		%vehicle9 = ChargerVehicle;
	}

	%count = VehicleSpawnSet.getCount();

	if (getRandom(3) == 0 && %count)
	{
		%index = getRandom(%count - 1);
		%spawn = VehicleSpawnSet.getObject(%index);

		initContainerRadiusSearch(
			%spawn.position, 128,
			$TypeMasks::VehicleObjectType |
			$TypeMasks::PlayerObjectType
		);

		if (!containerSearchNext())
		{
			%dataBlock = %vehicle[getRandom(%vehicleMax)];

			%obj = new (%className)()
			{
				dataBlock = %dataBlock;
				spawnBrick = %spawn;
			};

			MissionCleanup.add(%obj);

			%obj.setTransform(%spawn.getSpawnPoint());
			%obj.setNodeColor("ALL", getRandom() SPC getRandom() SPC getRandom() SPC 1);
		}
	}

	$spawnLoot = schedule(getRandom(10000, 60000), 0, spawnLoot);
}

function FxDTSBrick::checkLootSpawnLoad(%this)
{
	%name = %this.getName();

	if (getSubStr(%name, 0, 11) $= "_lootspawn_")
		%this.setItem(0);
}

package LootPackage
{
	function BrickVehicleSpawnData::onLoadPlant(%this, %obj)
	{
		Parent::onLoadPlant(%this, %obj);
		VehicleSpawnSet.add(%obj);
	}

	function BrickVehicleSpawnData::onPlant(%this, %obj)
	{
		Parent::onLoadPlant(%this, %obj);
		VehicleSpawnSet.add(%obj);
	}

	function FxDTSBrickData::onLoadPlant(%this, %obj)
	{
		Parent::onLoadPlant(%this, %obj);
		%obj.schedule(100, checkLootSpawnLoad);
	}

	function Item::respawn(%this)
	{
		if (%this.isLoot)
			%this.delete();
		else
			Parent::respawn(%this);
	}
};

activatePackage("LootPackage");

if (!isObject(VehicleSpawnSet))
	new SimSet(VehicleSpawnSet);

if (!isEventPending($spawnLoot))
	spawnLoot();
